const fs = require('fs')

function splitArrayIntoChunksOfLen(arr, len) {
    var chunks = [], i = 0, n = arr.length;
    while (i < n) {
        let c = arr.slice(i, i += len);
        
        if(c.length < len) {
            const lastBytes = Buffer.alloc(len - c.length).fill(0xFF);
            chunks.push(Buffer.concat([Buffer.from(c),lastBytes]))
        }
        else {
            chunks.push(Buffer.from(c));
        }
         
    }
    return chunks;
}

const getFirmwareChunksReadyForUpdate = (firmware_path) => {

    const buffer = fs.readFileSync(firmware_path)
    
    const first512 = buffer.slice(0,512);
    const restBytes = buffer.slice(512,buffer.length)
    let first512chunks = splitArrayIntoChunksOfLen(first512,128).map((el,index) => {return {index,chunk: el}})
    let restBytesChunks = splitArrayIntoChunksOfLen(restBytes,128).map((el,index) => {return {index: index + 4, chunk: el}})

    const chunks = restBytesChunks.concat(first512chunks)

    return chunks;

}

module.exports = {
    getFirmwareChunksReadyForUpdate
}