
let queue = [];
let index = -1;
let oldIndex = -1;
let timeoutRef = null
const timeoutInterval = 5000
const {sendUpdateResetCommand,
  sendPacketCommand,
  sendUpdateStartCommand,
  sendUpdateEndCommand} = require('./usb')

const addToQueue = (action, data) => { console.log({action,data}); queue.push({action,data}); if(index < 0 || oldIndex === index) index++; }

const queueCommandCompletedHandler = () => {

  if(index < queue.length - 1) index++;

  if(timeoutRef) { clearTimeout(timeoutRef); timeoutRef = null}

}

const repeatLastRequest = (client) => {

  if(timeoutRef) { clearTimeout(timeoutRef); timeoutRef = null}
  elaboraComando(client)


}

const timeout = (millis,client) => {
  //return;
  timeoutRef = setTimeout(() => {
    repeatLastRequest(client)
  },millis)

}

const elaboraComando = (client, reportStatus) => {

  if(!client || queue.length < 1) return

  const command = queue[index];
  const {action,data} = command;
  const {index: chunkIndex,chunk} = data
  //console.log({action,data})

  switch (action) {

    case 'sendPacketCommand':

      sendPacketCommand(true,client,chunkIndex,chunk, reportStatus);
      oldIndex = index
      timeout(timeoutInterval,client)
    break;

    case 'sendUpdateResetCommand':

      sendUpdateResetCommand(true,client);
      oldIndex = index
      timeout(timeoutInterval,client)
    break;

    case 'sendUpdateStartCommand':

      sendUpdateStartCommand(true,client);
      oldIndex = index
      timeout(timeoutInterval,client)
    break;

    case 'sendUpdateEndCommand':

      sendUpdateEndCommand(true,client);
      oldIndex = index
      timeout(timeoutInterval,client)
    break;


    default:
      oldIndex = index
      break;
  }

}

const handleQueue = (client, reportStatus) => {

  if(!client || queue.length < 1 || oldIndex === index) return;

  elaboraComando(client, reportStatus)


}

module.exports = {
  addToQueue,
  handleQueue,
  queueCommandCompletedHandler,
  repeatLastRequest
}


