import React, {useState} from 'react'
import '../assets/css/App.css'
import LinearProgress from '@material-ui/core/LinearProgress';
import Typography from '@material-ui/core/Typography';
import Box from '@material-ui/core/Box';
import Button from '@material-ui/core/Button';
//import logo from '../assets/jarvis.svg'
import logo from '../assets/firmware.png'
import TranslateIcon from '@material-ui/icons/Translate';

function LinearProgressWithLabel(props) {
  return (
    <Box sx={{ display: 'flex', alignItems: 'center' }}>
      <Box sx={{ width: '100%', mr: 1 }}>
        <LinearProgress variant="determinate" {...props} />
      </Box>
      {/* <Box sx={{ minWidth: 35 }}>
        <Typography variant="body2" color="text.secondary">{`${Math.round(
          props.value,
        )}%`}</Typography>
      </Box> */}
    </Box>
  );
}

function App(props) {

  const {frontend} = props;

  const [canUpdate, setCanUpdate] = useState(false)
  const [updateCompleted, setUpdateCompleted] = useState(false)
  const [status,setStatus] = useState(null)
  const [fase,setFase] = useState("")
  const [startUpdateClicked,setStartUpdateClicked] = useState(false)
  frontend.emit('ready',{});

  const [en,setEn] = useState(false)




  const startUpdate = () => {
    if(canUpdate) {
      frontend.emit('start_update',{})
      setStartUpdateClicked(true)
    }
  }

  frontend.on('update_allowed', (data) => {
    if(data.canUpdate !== canUpdate) setCanUpdate(data.canUpdate)
    console.log(data)
  })

  frontend.on('update_completed',(data) => {
    setUpdateCompleted(true)
    setStartUpdateClicked(false)
  })

  frontend.on('status',(data) => {
    setStatus(data)
  })

  frontend.on('fase',(data) => {
    setFase(data)
  })


  return (
    <div style={{display: 'flex', height: '100vh', flexDirection: 'column', justifyContent: 'center', alignItems: 'center',}}>
          {/* <div>{JSON.stringify(status)}</div>
          <div>{JSON.stringify(canUpdate)}</div>
          <div>{JSON.stringify(updateCompleted)}</div> */}
          <Button
            color="default"
            size="large"
            startIcon={<TranslateIcon />}
            onClick={() => {setEn(!en)}}
          >
            ITA/ENG
          </Button>
          <div style={{fontSize: '25pt', marginBottom: '20px'}}>MAGNETICDAYS JARVIS FIRMWARE UPDATE v04.00.D41</div>
          <img src={logo} width='300px'/>
          {!status && <div style={{heigth: '50vh', fontSize: '25pt', marginBottom: '50px'}}>{(canUpdate) ?
           (en) ? "Click on UPDATE button to start." : "Clicca sul tasto AGGIORNA per iniziare l'aggiornamento." :
           (en) ? "You need a Windows PC to update this Jarvis model. We are sorry." : "Ci dispiace, questo modello di Jarvis non supporta l'aggiornamento tramite MacOS, è necessario eseguirlo tramite un PC Windows"}
          </div>}
          {(status && !updateCompleted) && <div style={{fontSize: '35pt', margin: '20px'}}>{'( ' + fase + ' ) '} {Math.round(Number(status)) + '%'}</div>}
          {(status && !updateCompleted) && <div style={{width: '50%', height: '50px'}}><LinearProgressWithLabel value={Math.round(Number(status))}/></div>}
          {updateCompleted && <div style={{fontSize: '30pt'}}>{(en) ? "Jarvis updated successfully. Disconnect the cable and have fun." : "L'aggiornamento è concluso, puoi scollegare il cavo e utilizzare il tuo Jarvis."}</div>}
          {!status && <div>{canUpdate  && <Button variant="contained" color="primary" disabled={startUpdateClicked} onClick={() => {startUpdate()}}>{startUpdateClicked ? (en) ? "PLEASE WAIT..." : "ATTENDERE..." : (en) ? "UPDATE" : "AGGIORNA"}</Button>}</div>}
    </div>
  )
}

export default App
